function BitBoolean(args) {

    let value = 0;

    /**
     * 设置指定位为true
     * @param idx
     * @param bool
     * @returns {BitBoolean}
     */
    let setBitBool = (idx, bool) => {
        if (idx > -1) {
            if (bool===true) {
                value |= (1 << idx);
            } else {
                value &= ~(1<<idx);
            }
        }
        return this;
    }

    /**
     * 获取指定位的布尔值
     * @param idx
     * @returns {boolean}
     */
    let getBitBool = (idx) => {
        if (idx > -1) {
            let bv = 1 << idx;
            return (value & bv) === bv;
        } else {
            return false
        }
    }

    if (args instanceof Array) {
        for (let i=0; i<args.length; i++) {
            setBitBool(i, args[i]===true);
        }
    } else if (!isNaN(args)) {
        value = parseInt(args);
    }

    this.setBitBool = setBitBool;
    this.getBitBool = getBitBool;
    this.toValue = () => value;
    this.toArray = (len) => {
        let arr = [];
        for (let i=0; i<(len || 16); i++) {
            arr.push(getBitBool(i));
        }
        return arr;
    }

}